import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import java.io.IOException;
import java.util.Map;
import java.util.HashMap;

public abstract class AbstractHTTPCommand implements Command {
    AddressBook _addressBook = null;
    HttpServletRequest aRequest;
    HttpServletResponse aResponse;
    ServletContext sc;
    String viewPath;
    String resultPath;
    String errorPath;

    protected void initCommand(ServletContext sc, HttpServletRequest aRequest, HttpServletResponse aResponse, String viewPath, String resultPath, String errorPath) {
        this.setSc(sc);
        this.setARequest(aRequest);
        this.setAResponse(aResponse);
        this.setResultPath(resultPath);
        this.setErrorPath(errorPath);
        this.setViewPath(viewPath);
    }

    public void makeDataToView() {
        Map<String, String> numbers = new HashMap<String, String>();
        Map<String, String> comments = new HashMap<String, String>();

        for (Map.Entry<String, Contact> entry : _addressBook.getContacts().entrySet()) {
            numbers.put(entry.getKey(), entry.getValue().getNumber());
            comments.put(entry.getKey(), entry.getValue().getComment());
        }

        aRequest.setAttribute("numbers", numbers);
        aRequest.setAttribute("comments", comments);

        if (aRequest.getAttribute("message") == null) {
            aRequest.setAttribute("message", "");
        }
    }

    public HttpServletRequest getARequest() {
        return aRequest;
    }

    public void setARequest(HttpServletRequest aRequest) {
        this.aRequest = aRequest;
    }

    public HttpServletResponse getAResponse() {
        return aResponse;
    }

    public void setAResponse(HttpServletResponse aResponse) {
        this.aResponse = aResponse;
    }

    public String getResultPath() {
        return resultPath;
    }

    public void setResultPath(String resultPath) {
        this.resultPath = resultPath;
    }

    public String getErrorPath() {
        return errorPath;
    }

    public void setErrorPath(String errorPath) {
        this.errorPath = errorPath;
    }

    public String getViewPath() {
        return viewPath;
    }

    public void setViewPath(String viewPath) {
        this.viewPath = viewPath;
    }

    public ServletContext getSc() {
        return sc;
    }

    public void setSc(ServletContext sc) {
        this.sc = sc;
    }

    public void outputPage(String aJSPName, HttpServletRequest aRequest, HttpServletResponse aResponse) throws IOException, ServletException {
        RequestDispatcher dispatcher = aRequest.getRequestDispatcher("/jsps/" + aJSPName);
        dispatcher.forward(aRequest, aResponse);
    }
}
