import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AddHTTPCommand extends AbstractHTTPCommand {
    public AddHTTPCommand(ServletContext sc, HttpServletRequest aRequest, HttpServletResponse aResponse, String viewPath, String resultPath, String errorPath) {
        initCommand(sc, aRequest, aResponse, viewPath, resultPath, errorPath);
        this._addressBook = (AddressBook) sc.getAttribute("_addressBook");
    }


    public void execute() throws Exception {
        if (aRequest.getParameter("name") != null) {
            _addressBook.addContact(aRequest.getParameter("name"), aRequest.getParameter("number"), aRequest.getParameter("comment"));
            aRequest.setAttribute("message", "Контакт \"" + aRequest.getParameter("name") + "\" добавлен");
            makeDataToView();
            outputPage(getResultPath(), aRequest, aResponse);
        } else {

            aRequest.setAttribute("action", "add");
            aRequest.setAttribute("edit.name", "");
            aRequest.setAttribute("edit.number", "");
            aRequest.setAttribute("edit.comment", "");
            outputPage(this.getViewPath(), aRequest, aResponse);
        }
    }
}
