import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;

public class AddressBookServlet extends HttpServlet {
    private AddressBook _addressBook = null;

    public void init(ServletConfig aServletConfig) throws ServletException {
        super.init(aServletConfig);
        _addressBook = new AddressBook();
        ServletContext sc = this.getServletContext();
        sc.setAttribute("_addressBook", _addressBook);
    }

    protected void doGet(HttpServletRequest aRequest, HttpServletResponse aResponse) throws ServletException, IOException {
        handle(aRequest, aResponse);
    }

    protected void doPost(HttpServletRequest aRequest, HttpServletResponse aResponse) throws ServletException, IOException {
        handle(aRequest, aResponse);
    }

    private void handle(HttpServletRequest aRequest, HttpServletResponse aResponse) throws ServletException, IOException {
        aRequest.setCharacterEncoding("utf-8");
        Command cmd;
        CommandFactory cf = new CommandFactory(this.getServletConfig(), this.getServletContext());
        cmd = cf.getCommand(aRequest.getRequestURI().substring(aRequest.getContextPath().length()), aRequest, aResponse);
        if (cmd == null) {
            cmd = cf.getCommand("/", aRequest, aResponse);
        }

        try {
            cmd.execute();
        } catch (Exception e) {
            // oopst...
            e.printStackTrace();
        }
    }
}

