
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.*;
import java.io.IOException;

public class AuthFilter implements Filter {
    private FilterConfig filterConfig;

    public void init(FilterConfig filterConfig) throws ServletException {
        //System.out.println("Filter init");
        this.filterConfig = filterConfig;
    }

    public void doFilter(ServletRequest aRequest, ServletResponse aResponse, FilterChain filterChain)
            throws IOException, ServletException {
        //System.out.println("Filter used");
        HttpSession session = ((HttpServletRequest) aRequest).getSession();
        String name = (String) session.getAttribute("auth");
        if (name != null) {
            filterChain.doFilter(aRequest, aResponse);
        } else {
            aRequest.setAttribute("action", "auth");
            RequestDispatcher dispatcher = aRequest.getRequestDispatcher("/auth");
            dispatcher.forward(aRequest, aResponse);
        }
    }

    public void destroy() {
        //System.out.println("Filter dead");
        this.filterConfig = null;
    }
}
