import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Enumeration;
import java.lang.reflect.Constructor;

public class CommandFactory {
    ServletConfig config;
    ServletContext sc;

    public CommandFactory(ServletConfig config, ServletContext sc) {
        this.config = config;
        this.sc = sc;
    }

    public Command getCommand(String name, HttpServletRequest aRequest, HttpServletResponse aResponse) {
        if (name != null) {
            if (config.getInitParameter(name) != null) {
                try {
                    String key = config.getInitParameter(name);
                    Class cmd1 = Class.forName(config.getInitParameter(key + "Command"));
                    try {
                        Class[] parameterTypes = new Class[6];
                        parameterTypes[0] = ServletContext.class;
                        parameterTypes[1] = HttpServletRequest.class;
                        parameterTypes[2] = HttpServletResponse.class;
                        parameterTypes[3] = String.class;
                        parameterTypes[4] = String.class;
                        parameterTypes[5] = String.class;

                        Constructor constructor = cmd1.getConstructor(parameterTypes);
                        Object[] args = new Object[6];
                        args[0] = sc;
                        args[1] = aRequest;
                        args[2] = aResponse;
                        args[3] = config.getInitParameter(key + "View");
                        args[4] = config.getInitParameter(key + "Result");
                        args[5] = config.getInitParameter(key + "Error");

                        Command cmd = (Command) constructor.newInstance(args);
                        return cmd;
                    } catch (Exception e) {
                        e.printStackTrace();
                        return null;
                    }
                } catch (ClassNotFoundException e) {
                    e.printStackTrace();
                    return null;
                }
            }
        }
        return null;
    }
}
