import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletContext;

public class EditHTTPCommand extends AbstractHTTPCommand {
    public EditHTTPCommand(ServletContext sc, HttpServletRequest aRequest, HttpServletResponse aResponse, String viewPath, String resultPath, String errorPath) {
        initCommand(sc, aRequest, aResponse, viewPath, resultPath, errorPath);
        this._addressBook = (AddressBook) sc.getAttribute("_addressBook");
    }

    public void execute() throws Exception {
        if (aRequest.getParameter("number") == null) {
            _addressBook.removeContactByNumber(aRequest.getParameter("number"));
            aRequest.setAttribute("message", "Не определено, что редактировать");
            outputPage(this.getErrorPath(), aRequest, aResponse);
        } else if (aRequest.getParameter("edited") != null) {
            _addressBook.editContactByNumber(aRequest.getParameter("edited"),
                    aRequest.getParameter("name"), aRequest.getParameter("number"), aRequest.getParameter("comment"));
            aRequest.setAttribute("message", "Контакт \"" + aRequest.getParameter("name") + "\" отредактирован");
            makeDataToView();
            outputPage(this.getResultPath(), aRequest, aResponse);
        } else {
            Contact contact = _addressBook.getContactByNumber(aRequest.getParameter("number"));
            aRequest.setAttribute("action", "edit");
            aRequest.setAttribute("edit.name", contact.getName());
            aRequest.setAttribute("edit.number", contact.getNumber());
            aRequest.setAttribute("edit.comment", contact.getComment());
            outputPage(this.getViewPath(), aRequest, aResponse);
        }
    }
}
